Beep proc uses ebx wFreq:WORD, wDuration:WORD

    ; The frequency is in Hz and the duration in milliseconds.
    ; This procedure depends on InitFastTimer having been
    ; called.

    ; Calculate the terminal count and leave it in ECX.
    ;
    movzx ecx, wDuration
    add ecx, tickCount

    ; Calculate the count required to produce the specified
    ; frequency and load it into system timer 2.
    ;
    movzx ebx, wFreq
    mov eax, 1193182
    xor edx, edx
    div ebx
    cli
    out 42h, al
    jmp $+2
    mov al, ah
    out 42h, al
    sti

    ; Set the system timer 2 gate and speaker data enable
    ; bits to on, without changing other any other bits.
    ;
    in al, 61h
    or al, 3
    out 61h, al

    ; Wait for the tick count to reach the terminal count.
    ;
  @@:
    cmp tickCount, ecx
    jb @B

    ; Set the system timer 2 gate and speaker data enable
    ; bits to off, without changing other any other bits.
    ;
    in al, 61h
    and al, NOT 3
    out 61h, al

    ret

Beep endp